unit main;

interface

uses Windows, Classes, SysUtils, Dialogs,DxGoogleSearchApi,inifiles;

type
  TCommFortProcess = procedure(dwPluginID : DWORD; dID: DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD); stdcall;
  TCommFortGetData = function(dwPluginID : DWORD; dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD; stdcall;

function  PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer; cdecl; stdcall;
procedure PluginStop(); cdecl; stdcall;
procedure PluginShowOptions(); cdecl; stdcall;
procedure PluginShowAbout(); cdecl; stdcall;
procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD); cdecl; stdcall;
function  PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar;
            dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD; cdecl; stdcall;
function  fReadInteger(bInBuffer : PAnsiChar; var iOffset : Integer): Integer;
function  fReadText(bInBuffer : PAnsiChar; var iOffset : Integer): WideString;
procedure fWriteInteger(var bOutBuffer : PAnsiChar; var iOffset  : Integer; iValue : Integer);
procedure fWriteText(bOutBuffer : PAnsiChar; var iOffset  : Integer; uValue : WideString);
function  fTextToAnsiString(uText : WideString) : AnsiString;
function  fIntegerToAnsiString(iValue : Integer) : AnsiString;
procedure channel();
procedure channel_out();


exports PluginStart, PluginStop, PluginProcess, PluginGetData, PluginShowOptions, PluginShowAbout;

implementation
var
  dwPluginID : DWORD;
  CommFortProcess : TCommFortProcess;
  CommFortGetData : TCommFortGetData;
  Search: TDxGoogleSearch;
  iCaptcha,p:integer;
  bCaptchaOk:Boolean;
  sSender:string;
  sNick,sIp,sPass,sMale,sMsg_error,sMsg_main,sMsg_search,sAF,sSrchCnt,sChannel,schannellev,sBanned:string;
  iBanned:integer;
  aBanned:array[1..200] of string;
 //---------------------------------------------------------------------------
function fReadInteger(bInBuffer : PAnsiChar; var iOffset : Integer): Integer; //       
begin
	CopyMemory(@Result, bInBuffer + iOffSet, 4);
	iOffset := iOffset + 4;
end;

function fReadText(bInBuffer : PAnsiChar; var iOffset : Integer): WideString; //       
 var iLength : Integer;
begin
	CopyMemory(@iLength, bInBuffer + iOffSet, 4);
	iOffset := iOffset + 4;
	SetLength(Result, iLength);
	CopyMemory(@Result[1], bInBuffer + iOffSet, iLength * 2);
	iOffset := iOffset + iLength * 2;
end;
 //---------------------------------------------------------------------------
procedure fWriteInteger(var bOutBuffer : PAnsiChar; var iOffset  : Integer; iValue : Integer); //       
begin
	CopyMemory(bOutBuffer + iOffSet, @iValue, 4);
	iOffset := iOffset + 4;
end;
//---------------------------------------------------------------------------
procedure fWriteText(bOutBuffer : PAnsiChar; var iOffset  : Integer; uValue : WideString); //       
	var iLength : Integer;
begin
	iLength := Length(uValue);
	CopyMemory(bOutBuffer + iOffset, @iLength, 4);
	iOffset := iOffset + 4;

	CopyMemory(bOutBuffer + iOffSet, @uValue[1], iLength * 2);
	iOffset := iOffset + iLength * 2;
end;

//---------------------------------------------------------------------------
function fTextToAnsiString(uText : WideString) : AnsiString; //      
	var iLength : Integer;
begin
	//    ,
	//    ,
	//        
	iLength := Length(uText);

	SetLength(Result, 4 + iLength * 2);

	CopyMemory(@Result[1], @iLength, 4);
	CopyMemory(PAnsiChar(Result) + 4, @uText[1], iLength * 2);
end;
//---------------------------------------------------------------------------
function fIntegerToAnsiString(iValue : Integer) : AnsiString; //      
begin
	//    ,
	//    ,
	//        

	SetLength(Result, 4);
	CopyMemory(@Result[1], @iValue, 4);
end;
//---------------------------------------------------------------------------
procedure channel();
var aDataToSend : AnsiString;
chan,chanl:string;
begin
while pos(';',sChannel)<>0 do
  begin
    chan:=Copy(sChannel,1,Pos(';',sChannel)-1);
    delete(sChannel,1,Pos(';',sChannel));
    aDataToSend :=fTextToAnsiString(sNick)+  //  
    fTextToAnsiString(chan)+
    fIntegerToAnsiString(1)+
    fIntegerToAnsiString(0); //
    CommFortProcess(dwPluginID, 1026, PAnsiChar(aDataToSend), Length(aDataToSend));
  end;
aDataToSend :=fTextToAnsiString(sNick)+  //  
fTextToAnsiString(sChannel)+
fIntegerToAnsiString(1)+
fIntegerToAnsiString(0); //
CommFortProcess(dwPluginID, 1026, PAnsiChar(aDataToSend), Length(aDataToSend));
while pos(';',schannellev)<>0 do
  begin
    chanl:=Copy(schannellev,1,Pos(';',schannellev)-1);
    delete(schannellev,1,Pos(';',schannellev));
    aDataToSend :=fTextToAnsiString(sNick)+  //  
    fTextToAnsiString(chanl);
    CommFortProcess(dwPluginID, 1027, PAnsiChar(aDataToSend), Length(aDataToSend));
  end;
aDataToSend :=fTextToAnsiString(sNick)+  //  
fTextToAnsiString(chanl);
CommFortProcess(dwPluginID, 1027, PAnsiChar(aDataToSend), Length(aDataToSend));
end;

function PluginStart(dwThisPluginID : DWORD; func1 : TCommFortProcess; func2 : TCommFortGetData) : Integer;
var aDataToSend, aData : AnsiString;
    iSize, iReadOffset,se : Integer;
    uVersion : WideString;
    ini: TIniFile;
begin
  dwPluginID := dwThisPluginID;
	CommFortProcess := func1;
	CommFortGetData := func2;
  try
  ini := TIniFile.Create(getcurrentdir+'\Plugins\botinok.ini');
  {ini.WriteString('main', 'nick', 'Google');
  ini.WriteString('main', 'password', '123');
  ini.WriteString('main', 'ip', '127.0.0.1');
  ini.WriteString('main', 'male', '1');
  ini.WriteString('messages', 'msg_error', ' ');
  ini.WriteString('messages', 'msg_main', '   .  " [i][/i]"');
  ini.WriteString('messages', 'msg_search', '');
  ini.WriteString('channels', 'chlist', 'main');}
  sNick:=ini.ReadString('main', 'nick', 'Google');
  sPass:=ini.ReadString('main', 'password', '123');
  sIp:=ini.ReadString('main', 'ip', '127.0.0.1');
  sMale:=ini.ReadString('main', 'male', '1');
  sAF:=ini.ReadString('main', 'antiflood', '0');
  sSrchCnt:=ini.ReadString('main', 'searchcount', '8');
  sMsg_error:=ini.ReadString('messages', 'msg_error', ' ');
  sMsg_Main:=ini.ReadString('messages', 'msg_main', '   .  " [i][/i]"');
  sMsg_search:=ini.ReadString('messages', 'msg_search', '');
  sChannel:=ini.ReadString('channels', 'chlist', 'main');
  schannellev:=ini.ReadString('channels', 'chleave', 'uknown');
  sBanned:= ini.ReadString('users', 'banned', 'test');
  while pos(';',sBanned)<>0 do
  begin
    Inc(Ibanned);
    aBanned[iBanned]:=Copy(sBanned,1,Pos(';',sBanned)-1);
    delete(sBanned,1,Pos(';',sBanned));
  end;
    Inc(Ibanned);
    aBanned[iBanned]:=sBanned;
  except
    ShowMessage('     botinok.ini   !');
    exit;
  end;
	//  
  if sMale='1' then se:=0 else se:=1;
	aDataToSend := fTextToAnsiString(sNick)+  //
	 fTextToAnsiString(sIp)+ //IP-
	 fIntegerToAnsiString(0)+  //   
	 fTextToAnsiString(sPass)+   //
	 fIntegerToAnsiString(se); // 
	CommFortProcess(dwPluginID, 1001, PAnsiChar(aDataToSend), Length(aDataToSend));
	//     (  ):
	iSize := CommFortGetData(dwPluginID, 2001, nil, 0, nil, 0); //  
	SetLength(aData, iSize);
	CommFortGetData(dwPluginID, 2001, PAnsiChar(aData), iSize, nil, 0);// 
	iReadOffset := 0;
	uVersion := fReadText(PAnsiChar(aData), iReadOffset);
  Search := TDxGoogleSearch.Create;
	//ShowMessage('     CommFort  - ' + uVersion);
  Randomize;
	// :
	//TRUE -   
	//FALSE -  
  ini.Free;
  channel;
	Result := Integer(TRUE);
end;
//---------------------------------------------------------------------------
procedure PluginStop();
begin
  for p:=1 to iBanned do aBanned[p]:='';
	//      
  sNick:='';
  sIp:='';
  sPass:='';
  sMale:='';
  sMsg_error:='';
  sMsg_main :='';
  sMsg_search:='';
  sAF:='';
  sSrchCnt:='';
  sChannel:='';
  schannellev:='';
  sBanned:='';
  iCaptcha:=0;
  p:=0;
  ibanned:=0;
  sSender:='';
  Search.Free;
end;
//---------------------------------------------------------------------------

function parser(sInput0:string):string;
label ds0,ds1,ds2,ds3,ds4,ds5;
var iPos:integer; sInput:string;
begin
  sInput:=sInput0;
  iPos:=0;
  ds0:if Pos('&quot;',sInput)<>0 then
  begin
    iPos:=Pos('&quot;',sInput);
    Delete(sInput,iPos,6);
    Insert('"',sInput,iPos);
    goto ds0;
  end;
    ds1:if Pos('&amp;',sInput)<>0 then
  begin
    iPos:=Pos('&amp;',sInput);
    Delete(sInput,iPos,5);
    Insert('&',sInput,iPos);
    goto ds1;
  end;
    ds2:if Pos('&nbsp;',sInput)<>0 then
  begin
    iPos:=Pos('&nbsp;',sInput);
    Delete(sInput,iPos,6);
    Insert(' ',sInput,iPos);
    goto ds2;
  end;
      ds3:if Pos('&#39;',sInput)<>0 then
  begin
    iPos:=Pos('&#39;',sInput);
    Delete(sInput,iPos,5);
    Insert(#39,sInput,iPos);
    goto ds3;
  end;
      ds4:if Pos('&gt;',sInput)<>0 then
  begin
    iPos:=Pos('&gt;',sInput);
    Delete(sInput,iPos,5);
    Insert('>',sInput,iPos);
    goto ds4;
  end;
      ds5:if Pos('&lt;',sInput)<>0 then
  begin
    iPos:=Pos('&lt;',sInput);
    Delete(sInput,iPos,5);
    Insert('<',sInput,iPos);
    goto ds5;
  end;
  parser:=sInput;
end;


procedure PluginProcess(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD);
var iReadOffset, iSenderIcon, iMessageMode,iReason : Integer;
    aDataToSend : AnsiString;
    uVirtualUserLogin, uSenderLogin, uSenderIP, uChannel, uText,uTheme,uGreet : String;
  i,j,k: Integer;
  Rec: TDxSearchRecord;
  reznum:integer;
  isBanned:Boolean;
procedure send_text(messag:string);
begin
aDataToSend := fTextToAnsiString(sNick)+  //  
fIntegerToAnsiString(0)+  // 
fTextToAnsiString(uChannel)+
fTextToAnsiString(messag); //
CommFortProcess(dwPluginID, 1020, PAnsiChar(aDataToSend), Length(aDataToSend));
end;
begin
	iReadOffset := 0;
  bCaptchaOk:=False;
	if (dwID = 1070) then //   
	begin
		//   
 		uVirtualUserLogin := fReadText(bInBuffer, iReadOffset);
		uSenderLogin := fReadText(bInBuffer, iReadOffset);
		uSenderIP := fReadText(bInBuffer, iReadOffset);
		iSenderIcon := fReadInteger(bInBuffer, iReadOffset);
		uChannel := fReadText(bInBuffer, iReadOffset);
		iMessageMode := fReadInteger(bInBuffer, iReadOffset);
		uText := fReadText(bInBuffer, iReadOffset);
    for k:=1 to iBanned do if uSenderLogin=aBanned[k] then isBanned:=true;
    if (Pos(IntToStr(iCaptcha),uText)<>0) and (uSenderLogin<>sNick) and (uSenderLogin=sSender) then bCaptchaOk:=True else bCaptchaOk:=False;
    if ((Pos(sNick+'> ',uText)<>0)and (isBanned=False)) or ((Pos('!'+sMsg_search,uText)<>0)and (isBanned=false)) then
      begin
        if (Pos(sNick+'> ',uText)<>0) then delete(utext,1,Length(sNick)+2);
        if (Pos('!'+sMsg_search,uText)<>0) then delete(utext,1,1);
        if Pos(sMsg_search,uText)<>0 then
        begin
         try
          delete(utext,1,Length(sMsg_search));
          Search.SearchStart := 0;
	        Search.SearchType := TDxSearchType(0);
	        Search.Search(utext);
          sSender:=uSenderLogin;
          iCaptcha:=Random(999);
          if sAF='0' then
          begin
           if StrToInt(sSrchCnt)>Search.Records.Count - 1 then reznum:=Search.Records.Count - 1 else reznum:=strtoint(sSrchCnt)-1;
           for i := 0 to reznum do
	            begin
               Rec := Search.Records.Records[i];
               uText:=uSenderLogin+'> '+'[url='+rec.values[1]+']'+parser(utf8toansi(rec.values[6]))+'[/url]';
	  	         send_text(uText); //
              end;
          end else send_text(uSenderLogin+'>   : '+inttostr(iCaptcha)); //
         except
          begin
           utext:=uSenderLogin+'> '+sMsg_error;
           send_text(uText); //
          end;
          end;
        end else
            begin
              if Pos(IntToStr(iCaptcha),uText)=0 then
              begin
               uText:=usenderlogin+'> '+sMsg_main ;
	  	         send_text(uText); //
              end;
            end;
      end;
      if (bCaptchaOk=True) and (sAF='1')and(isBanned=false) then
      begin
        try
        if StrToInt(sSrchCnt)>Search.Records.Count - 1 then reznum:=Search.Records.Count - 1 else reznum:=strtoint(sSrchCnt)-1;
	      for i := 0 to reznum do
	            begin
               Rec := Search.Records.Records[i];
               uText:=uSenderLogin+'> '+'[url='+rec.values[1]+']'+parser(utf8toansi(rec.values[6]))+'[/url]';
	  	         send_text(uText); //
              end;
              bCaptchaOk:=false;
              iCaptcha:=99965;
                 except
          begin
           utext:=uSenderLogin+'> '+sMsg_error;
           send_text(uText); //
          end;
          end;
      end;
   end;
  iReadOffset := 0;
  if (dwID = 1091) then
  begin
    uVirtualUserLogin:=fReadText(bInBuffer, iReadOffset);
    uChannel:=fReadText(bInBuffer, iReadOffset);
    iReason:=fReadInteger(bInBuffer, iReadOffset);
    if iReason=1 then ShowMessage('   .     ');
    if iReason=2 then ShowMessage('       ');
  end;

end;
//---------------------------------------------------------------------------
function PluginGetData(dwID : DWORD; bInBuffer : PAnsiChar; dwInBufferSize : DWORD; bOutBuffer : PAnsiChar; dwOutBufferSize : DWORD): DWORD;
var iWriteOffset, iSize : Integer; //       
    uName : WideString;
begin

      //   
	iWriteOffset := 0;

	//  dwOutBufferSize       ,   

	if (dwID = 2800) then // 
	begin
		if (dwOutBufferSize = 0) then
			Result := 4 //   ,    
		else
		begin
			fWriteInteger(bOutBuffer, iWriteOffset, 0); //    
			Result := 4;//    
		end;
	end
	else
	if (dwID = 2810) then //  (  )
	begin
		uName := ' (0.9.1 beta)';// 
		iSize := Length(uName) * 2 + 4;

		if (dwOutBufferSize = 0) then
			Result := iSize //   ,    
		else
		begin
			fWriteText(bOutBuffer, iWriteOffset, uName);
			Result := iSize;//    
		end;
	end
	else
		Result := 0;//  -   
end;
//---------------------------------------------------------------------------
procedure PluginShowOptions();
begin
ShowMessage('    botinok.ini   Plugins    .'+#13+#13+' :'+#13+'[main]'+#13+'nick=Nickname (  )'+#13+'password=Password (   )'+#13+'ip=192.168.0.1 (IP- ,   )'+#13+'male=1 (  , 1-, 0-)'+#13+'antiflood=1 ( )'+#13+'searchcount=8 (   (  8,  ))'+#13+'[messages]'+#13+'msg_error= (,       )'+#13+'msg_main=Hello (  )'+#13+'msg_search= (  )'+#13+'[channels]'+#13+'chlist=main;some ( ,     ,    )'+#13+'chleave=bad;verybad ( ,     )'+#13+'[users]'+#13+'banned=test;test1 (,     )');
end;

//---------------------------------------------------------------------------
procedure PluginShowAbout();
begin
ShowMessage(' 0.9.1 beta'+#13+#13+'    '+#13+'  Commfort   '+#13+' '+#13+#13+':'+#13+': dr1v3'+#13+'-: KaMaToZzz'+#13+'e-mail: 2800@list.ru'+#13+'ICQ: 258451004'+#13+#13+'Donate:'+#13+'Z382951440275, R336698390295'+#13+'U406595430304');
end;


procedure channel_out();
var aDataToSend : AnsiString;
begin
{aDataToSend :=fTextToAnsiString(sNick)+  //  
fTextToAnsiString(frm_Settings.edt_out.text);
CommFortProcess(dwPluginID, 1027, PAnsiChar(aDataToSend), Length(aDataToSend)); }
end;

end.
